/*
** OpenBus Demo - Orbix 6.3
** client.cpp
*/

#include <fstream>
#include <iostream>

#include "stubs/hello.hh"

using namespace std;

int main(int argc, char* argv[]) {
    
  CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);

  try {
  
    char objref_text[5000];
    ifstream is(argv[1]);
    if (is.good())
    {
        is >> objref_text;
    };
  
    CORBA::Object_var obj =  orb->string_to_object(objref_text);
    if (CORBA::is_nil(obj))
    {
    	cout << "NAAAOOOO" <<endl;
        return 1;
    }
  
    cout << "Tentando fazer narrow para demoidl::hello::IHello..." <<endl;
  
    demoidl::hello::IHello_var hello = demoidl::hello::IHello::_narrow(obj);
  
    cout << "Fazendo chamada remota sayHello()..." << endl;
  
    hello->sayHello();
  
    cout << "Desconectando-se do barramento..." << endl;
  
    orb->shutdown(IT_TRUE);
  }
  catch (const CORBA::Exception& e)
  {
      cout << "Exception occurred: " << e <<  endl;
      if (!CORBA::is_nil(orb))
      {
          orb->shutdown(IT_TRUE);
      }
  }

  return 0;
}

